#include "fdf.h"

t_trnsf	*transfor_mat_init()
{
	t_trnsf	*trnsf;

	trnsf = NULL;
	if ((trnsf = malloc(sizeof(t_trnsf))))
	{
		trnsf->tr = mat4_init();
		trnsf->xr = mat4_init();
		trnsf->yr = mat4_init();
		trnsf->zr = mat4_init();
		trnsf->fin = mat4_init();
	}
	return (trnsf);
}

int 	max_z(t_map *map)
{
	int z;
	t_list *tmp;

	z = 0;
	tmp = map->lst_map;
	while (tmp)
	{
		if (((t_vec *)(tmp->content))->z > z)
		{
			z = (int)((t_vec *)(tmp->content))->z;
		}
		tmp = tmp->next;
	}
	return (z);
}

void	transform(t_mat4 *mat, t_map *map)
{
	t_list *vec_list;
	int 	i;
	int 	j;

	vec_list = map->lst_map;
	i = 0;
	while (i < map->height)
	{
		j = 0;
		while (j < map->width)
		{
			vec_mat_mult(mat, vec_list->content, &map->arr_pnt[i][j]);
			vec_list = vec_list->next;
			j++;
		}
		i++;
	}
}

t_mat4 *viewport_mat_init(int x, int y)
{
	t_mat4 *m;

	if ((m = malloc(sizeof(t_mat4))))
	{
		m->mx[0][0] = (double)x / 2;
		m->mx[0][1] = 0;
		m->mx[0][2] = 0;
		m->mx[0][3] = 0;
		m->mx[1][0] = 0;
		m->mx[1][1] = (double)y / 2;
		m->mx[1][2] = 0;
		m->mx[1][3] = 0;
		m->mx[2][0] = 0;
		m->mx[2][1] = 0;
		m->mx[2][2] = 1;
		m->mx[2][3] = 0;
		m->mx[3][0] = ((double)x - 1) / 2;
		m->mx[3][1] = ((double)y - 1) / 2;
		m->mx[3][2] = 0;
		m->mx[3][3] = 1;
	}
	return (m);
}

t_mat4	*orth_mat_init(int l, int r, int b, int t, int n, int f)
{
	t_mat4 *orth;

	if ((orth = malloc(sizeof(t_mat4))))
	{
		orth->mx[0][0] = 2 / ((double)r - (double)l);
		orth->mx[0][1] = 0;
		orth->mx[0][2] = 0;
		orth->mx[0][3] = 0;
		orth->mx[1][0] = 0;
		orth->mx[1][1] = 2 / ((double)t - (double)b);
		orth->mx[1][2] = 0;
		orth->mx[1][3] = 0;
		orth->mx[2][0] = 0;
		orth->mx[2][1] = 0;
		orth->mx[2][2] = 2 / ((double)n - (double)f);
		orth->mx[2][3] = 0;
		orth->mx[3][0] = - (((double)r + (double)l) / ((double)r - (double)l));
		orth->mx[3][1] = - (((double)t + (double)b) / ((double)t - (double)b));
		orth->mx[3][2] = - (((double)n + (double)f) / ((double)n - (double)f));
		orth->mx[3][3] = 1;
	}
	return (orth);
}

void	draw(t_map *map, t_mlx *m)
{
	int 	x;
	int 	y;
	int 	i;
	int 	j;

	i = 0;
	while (i < map->height)
	{
		j = 0;
		while (j < map->width)
		{
			x = map->arr_pnt[i][j].x;
			y = map->arr_pnt[i][j].y;
			mlx_pixel_put(m->mlx, m->win, x, y, 0xFFFFFF);
			if (i == map->height - 1 && j < map->width - 1)
				line(map->arr_pnt[i][j], map->arr_pnt[i][j + 1], m);
			else if (i < map->height - 1 && j == map->width - 1)
				line(map->arr_pnt[i][j], map->arr_pnt[i + 1][j], m);
			else if (i < map->height - 1 && j < map->width - 1)
			{
				line(map->arr_pnt[i][j], map->arr_pnt[i + 1][j], m);
				line(map->arr_pnt[i][j], map->arr_pnt[i][j + 1], m);
			}
			j++;
		}
		i++;
	}
}

void	render(t_map *map, t_mlx *m, int x, int y)
{
	t_mat4	*vp;
	t_mat4	*orth;
	t_mat4	*final;
	t_mat4	*rot_z;
	t_mat4	*rot_y;
	t_mat4	*rot_x;
	t_mat4	*translate;
	t_mat4	*scale;

	rot_x = mat4_init();
	rot_y = mat4_init();
	rot_z = mat4_init();
	translate = mat4_init();
	scale = mat4_init();
	vp = viewport_mat_init(x, y);
	orth = orth_mat_init(0, map->width + 1, 0, map->height + 1, 0, 20);
	mat4_x_rot(rot_x, 20);
	mat4_z_rot(rot_z, 45);
	mat4_y_rot(rot_y, 20);
	mat4_scale(scale, 1, 1, 1);
	mat4_translate(translate, 0, 0, 0);
	final = mat4_mult(vp, orth);
	final = mat4_mult(rot_x, final);
	final = mat4_mult(translate, final);
	final = mat4_mult(rot_y ,final);
	final = mat4_mult(scale, final);
	transform(final, map);
	draw(map, m);
}

